Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 13399)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 13400)
@@ -132,7 +132,14 @@
             self.redirect(self.url(self.context, '@@index'))
             return
+
         student = self.student
-
-        if school(student) == 'PT':
+        current_session = student['studycourse'].current_session
+        try:
+            academic_session = grok.getSite()['configuration'][str(current_session)]
+        except KeyError:
+            self.flash(_(u'Session configuration object is not available.'), type='danger')
+            self.redirect(self.url(self.context, '@@index'))
+            return
+        if school(student) == 'pt':
             self.product_id = PRODUCT_ID_PT
         else:
@@ -145,5 +152,5 @@
         # requirement applies to students in state 'cleared' and
         # entry_session greater than 2013 only.
-        if self.context.p_category == 'schoolfee' and \
+        if self.context.p_category.startswith('schoolfee') and \
             student.state == CLEARED and \
             student.entry_session > 2012:
@@ -151,5 +158,5 @@
             for ticket in student['payments'].values():
                 if ticket.p_state == 'paid' and \
-                    ticket.p_category == 'clearance':
+                    ticket.p_category.startswith('clearance'):
                     acceptance_fee_paid = True
                     break
@@ -171,7 +178,13 @@
         provider_amt = 0.0
 
-        # PT
-        if school(student) == 'pt':
-            if self.context.p_category == 'schoolfee':
+        # Schoolfee
+        if self.context.p_category.startswith('schoolfee'):
+            if school(student) == 'pt':
+                # PT schoolfee settings
+                provider_amt = 1900.0
+                joint_venture_amt = 1100.0
+                aaue_share_amt = 1000.0
+                student_union_due_amt = academic_session.union_fee
+                student_welfare_assurance_amt = academic_session.welfare_fee
                 xmldict['institution_bank_id'] = '7'
                 xmldict['institution_acct'] = '1014847058'
@@ -180,12 +193,20 @@
                 else:
                     self.pay_item_id = '105'
-                provider_amt = 1900.0
-                joint_venture_amt = 1100.0
-                aaue_share_amt = 1000.0
-                student_union_due_amt = 1000.0
-                student_welfare_assurance_amt = 500.0
-                xmldict['provider_amt'] = 100 * provider_amt
-                xmldict['joint_venture_amt'] = 100 * joint_venture_amt
-                xmldict['aaue_share_amt'] = 100 * aaue_share_amt
+            else:
+                # REGULAR schoolfee settings
+                provider_amt = 1500.0
+                joint_venture_amt = 1000.0
+                aaue_share_amt = 1500.0
+                student_union_due_amt = academic_session.union_fee
+                student_welfare_assurance_amt = academic_session.welfare_fee
+                xmldict['institution_bank_id'] = '117'
+                xmldict['institution_acct'] = '1010827641'
+                self.pay_item_id = '101'
+
+            xmldict['provider_amt'] = 100 * provider_amt
+            xmldict['joint_venture_amt'] = 100 * joint_venture_amt
+            xmldict['aaue_share_amt'] = 100 * aaue_share_amt
+            if self.context.p_category == 'schoolfee_incl':
+                # Schoolfee including additional fees
                 xmldict['student_union_due_amt'] = 100 * student_union_due_amt
                 xmldict['student_welfare_assurance_amt'] = 100 * student_welfare_assurance_amt
@@ -208,5 +229,26 @@
 </item_details>
 </payment_item_detail>""" % xmldict
-            elif self.context.p_category == 'clearance':
+            else:
+                # Schoolfee without additional fees
+                xmldict['institution_amt'] = 100 * (
+                    self.context.amount_auth
+                    - provider_amt
+                    - joint_venture_amt
+                    - aaue_share_amt
+                    - GATEWAY_AMT)
+                xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
+<item_detail item_id="3" item_name="Joint Venture" item_amt="%(joint_venture_amt)d" bank_id="51" acct_num="5060023759" />
+<item_detail item_id="4" item_name="AAUE Share" item_amt="%(aaue_share_amt)d" bank_id="51" acct_num="5060020947" />
+</item_details>
+</payment_item_detail>""" % xmldict
+
+
+        # Clearance
+        elif self.context.p_category.startswith('clearance'):
+            if school(student) == 'pt':
+                # PT clearance settings
                 if student.current_mode == 'found':
                     self.pay_item_id = '102'
@@ -215,6 +257,15 @@
                 xmldict['institution_acct'] = '1014066976'
                 xmldict['institution_bank_id'] = '117'
-                gown_fee_amt = 2000.0
-                aaue_fl_fee_amt = 800.0
+            else:
+                # REGULAR clearance settings
+                self.pay_item_id = '102'
+                xmldict['institution_acct'] = '1010827641'
+                xmldict['institution_bank_id'] = '117'
+
+
+            if self.context.p_category == 'clearance_incl':
+                # Clearance including additional fees
+                gown_fee_amt = academic_session.matric_gown_fee
+                aaue_fl_fee_amt = academic_session.lapel_fee
                 xmldict['gown_fee_amt'] = 100 * gown_fee_amt
                 xmldict['aaue_fl_fee_amt'] = 100 * aaue_fl_fee_amt
@@ -231,127 +282,102 @@
 </item_details>
 </payment_item_detail>""" % xmldict
+
             else:
-                self.flash('Not applicable', type='danger')
-                self.redirect(self.url(self.context, '@@index'))
-                return
-
-        # REGULAR
-        else:
-            if self.context.p_category == 'schoolfee':
-                self.pay_item_id = '101'
-                xmldict['institution_bank_id'] = '117'
-                xmldict['institution_acct'] = '1010827641'
-                provider_amt = 1500.0
-                xmldict['provider_amt'] = 100 * provider_amt
-                aaue_share_amt = 1500.0
-                xmldict['aaue_share_amt'] = 100 * aaue_share_amt
-                joint_venture_amt = 1000.0
-                xmldict['joint_venture_amt'] = 100 * joint_venture_amt
+                # Clearance without additional fees
                 xmldict['institution_amt'] = 100 * (
                     self.context.amount_auth
-                    - provider_amt
-                    - joint_venture_amt
-                    - aaue_share_amt
                     - GATEWAY_AMT)
                 xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="Joint Venture" item_amt="%(joint_venture_amt)d" bank_id="117" acct_num="1014066969" />
-<item_detail item_id="4" item_name="AAUE Share" item_amt="%(aaue_share_amt)d" bank_id="11" acct_num="0030656377" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'clearance':
-                self.pay_item_id = '102'
-                xmldict['institution_acct'] = '1010827641'
-                xmldict['institution_bank_id'] = '117'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'union':
-                self.pay_item_id = '103'
-                xmldict['institution_acct'] = '1006360118'
-                xmldict['institution_bank_id'] = '123'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'lapel':
-                self.pay_item_id = '104'
-                xmldict['institution_acct'] = '4010660109'
-                xmldict['institution_bank_id'] = '51'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'welfare':
-                self.pay_item_id = '105'
-                xmldict['institution_acct'] = '1006407792'
-                xmldict['institution_bank_id'] = '123'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'matric_gown':
-                self.pay_item_id = '106'
-                xmldict['institution_acct'] = '5060023429'
-                xmldict['institution_bank_id'] = '51'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'concessional':
-                self.pay_item_id = '107'
-                xmldict['institution_acct'] = '1010835352'
-                xmldict['institution_bank_id'] = '117'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'medical':
-                self.pay_item_id = '108'
-                xmldict['institution_acct'] = '1010827641'
-                xmldict['institution_bank_id'] = '117'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif self.context.p_category == 'hostel_maintenance':
-                self.pay_item_id = '109'
-                xmldict['institution_acct'] = '1006406795'
-                xmldict['institution_bank_id'] = '123'
-                xmldict['institution_amt'] = 100 * (
-                    self.context.amount_auth - GATEWAY_AMT)
-                xmltext = """<payment_item_detail>
+</item_details>
+</payment_item_detail>""" % xmldict
+
+        # Union Due
+        elif self.context.p_category == 'union':
+            self.pay_item_id = '103'
+            xmldict['institution_acct'] = '1006360118'
+            xmldict['institution_bank_id'] = '123'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+
+        # Lapel
+        elif self.context.p_category == 'lapel':
+            self.pay_item_id = '104'
+            xmldict['institution_acct'] = '4010660109'
+            xmldict['institution_bank_id'] = '51'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+
+        # Welfare
+        elif self.context.p_category == 'welfare':
+            self.pay_item_id = '105'
+            xmldict['institution_acct'] = '1006407792'
+            xmldict['institution_bank_id'] = '123'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+
+        # Matric Gown
+        elif self.context.p_category == 'matric_gown':
+            self.pay_item_id = '106'
+            xmldict['institution_acct'] = '5060023429'
+            xmldict['institution_bank_id'] = '51'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+
+        # Concessional
+        elif self.context.p_category == 'concessional':
+            self.pay_item_id = '107'
+            xmldict['institution_acct'] = '1010835352'
+            xmldict['institution_bank_id'] = '117'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+
+        # Medical
+        elif self.context.p_category == 'medical':
+            self.pay_item_id = '108'
+            xmldict['institution_acct'] = '1010827641'
+            xmldict['institution_bank_id'] = '117'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+
+        # Hostel Maintenance
+        elif self.context.p_category == 'hostel_maintenance':
+            self.pay_item_id = '109'
+            xmldict['institution_acct'] = '1006406795'
+            xmldict['institution_bank_id'] = '123'
+            xmldict['institution_amt'] = 100 * (
+                self.context.amount_auth - GATEWAY_AMT)
+            xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13399)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13400)
@@ -105,5 +105,7 @@
         self.certificate.study_mode = 'ug_pt'
         self.student['studycourse'].entry_session = 2013
-        self.student['studycourse'].certificate.school_fee_1 = 51750.0
+        self.student['studycourse'].certificate.school_fee_1 = 50250.0
+        self.app['configuration']['2004'].union_fee = 1000.0
+        self.app['configuration']['2004'].welfare_fee = 500.0
         # Manager can access InterswitchForm
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
@@ -112,5 +114,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         self.assertTrue('ticket created' in self.browser.contents)
@@ -137,5 +139,6 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="School Fee" item_amt="4600000" bank_id="7" '
+            'item_name="School Fee plus Student Union Dues and Welfare Ass." '
+            'item_amt="4600000" bank_id="7" '
             'acct_num="1014847058"' in self.browser.contents)
 
@@ -184,5 +187,7 @@
     def test_interswitch_form_pt_acceptance_fees(self):
         self.certificate.study_mode = 'ug_pt'
-        self.app['configuration']['2004'].clearance_fee_pt = 43050.0
+        self.app['configuration']['2004'].clearance_fee_pt = 40250.0
+        self.app['configuration']['2004'].matric_gown_fee = 2000.0
+        self.app['configuration']['2004'].lapel_fee = 800.0
         # Manager can access InterswitchForm
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
@@ -191,5 +196,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['clearance']
+        self.browser.getControl(name="form.p_category").value = ['clearance_incl']
         self.browser.getControl("Create ticket").click()
         self.assertTrue('ticket created' in  self.browser.contents)
@@ -208,5 +213,6 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Acceptance Fee" item_amt="4000000" bank_id="117" '
+            'item_name="Acceptance Fee plus Matric Gown Fee and Lapel Fee" '
+            'item_amt="4000000" bank_id="117" '
             'acct_num="1014066976"' in self.browser.contents)
 
@@ -259,7 +265,4 @@
             '<span>1567.0</span>' in self.browser.contents)
         self.payment_url = self.browser.url
-        self.browser.getLink("CollegePAY", index=0).click()
-        self.assertTrue('<div class="alert alert-danger">Not applicable</div>'
-                        in self.browser.contents)
         self.certificate.study_mode = 'ug_ft'
         self.browser.getLink("CollegePAY", index=0).click()
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/payments.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/payments.py	(revision 13399)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/payments.py	(revision 13400)
@@ -49,5 +49,5 @@
     def redeemTicket(self):
         student = self.student
-        if self.p_category in ('schoolfee', 'schoolfee_1'):
+        if self.p_category.startswith('schoolfee'):
             # Bypass activation code creation if next session
             # can be started directly.
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py	(revision 13399)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py	(revision 13400)
@@ -133,5 +133,5 @@
         elif category == 'medical':
             amount = academic_session.medical_fee
-        elif category == 'clearance':
+        elif category.startswith('clearance'):
             if student.faccode == 'FP':
                 amount = academic_session.clearance_fee_fp
@@ -143,7 +143,13 @@
                 amount = academic_session.clearance_fee
             p_item = student['studycourse'].certificate.code
+            # Add Matric Gown Fee and Lapel Fee
+            if category == 'clearance_incl':
+                if amount is None:
+                    # Otherwise we can't add somtehing
+                    amount = 0.0
+                amount += academic_session.matric_gown_fee + academic_session.lapel_fee
         elif category == 'late_registration':
             amount = academic_session.late_registration_fee
-        elif category == 'schoolfee':
+        elif category.startswith('schoolfee'):
             try:
                 certificate = student['studycourse'].certificate
@@ -172,4 +178,10 @@
             else:
                 return _('Wrong state.'), None
+            # Add Student Union Fee and Welfare Assurance
+            if category == 'schoolfee_incl':
+                if amount is None:
+                    # Otherwise we can't add somtehing
+                    amount = 0.0
+                amount += academic_session.welfare_fee + academic_session.union_fee
         if amount in (0.0, None):
             return _(u'Amount could not be determined.'), None
Index: main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 13399)
+++ main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 13400)
@@ -31,5 +31,7 @@
         'schoolfee_1': 'School Fee 1st instalment',
         'schoolfee_2': 'School Fee 2nd instalment',
+        'schoolfee_incl': 'School Fee plus Student Union Dues and Welfare Ass.',
         'clearance': 'Acceptance Fee',
+        'clearance_incl': 'Acceptance Fee plus Matric Gown Fee and Lapel Fee',
         'hostel_maintenance': 'Hostel Maintenance Fee',
         'application': 'Application Fee',
@@ -51,5 +53,7 @@
         #'schoolfee_1': 'School Fee 1st instalment',
         #'schoolfee_2': 'School Fee 2nd instalment',
+        'schoolfee_incl': 'School Fee plus Students Union Due and Welfare Ass.',
         'clearance': 'Acceptance Fee',
+        'clearance_incl': 'Acceptance Fee plus Matric Gown Fee and Lapel Fee',
         'hostel_maintenance': 'Hostel Maintenance Fee',
         'application': 'Application Fee',