Index: main/waeup.aaue/trunk/src/waeup/aaue/interfaces.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interfaces.py	(revision 13409)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interfaces.py	(revision 13410)
@@ -141,10 +141,4 @@
         )
 
-    medical_fee = schema.Float(
-        title = _(u'Medical Student Acceptance Fee'),
-        default = 0.0,
-        required = True,
-        )
-
     coursereg_deadline = schema.Datetime(
         title = _(u'Course Reg. Deadline'),
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 13409)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 13410)
@@ -271,5 +271,5 @@
                 xmldict['institution_bank_id'] = '117'
 
-            if self.context.p_category == 'clearance_incl':
+            if self.context.p_category.endswith('_incl'):
                 # Clearance including additional fees
                 gown_fee_amt = academic_session.matric_gown_fee - \
@@ -373,18 +373,4 @@
 </payment_item_detail>""" % xmldict
 
-        # Medical Acceptance
-        elif self.context.p_category == 'medical':
-            self.pay_item_id = '108'
-            xmldict['institution_acct'] = '1010827641'
-            xmldict['institution_bank_id'] = '117'
-            xmldict['institution_amt'] = 100 * (
-                self.context.amount_auth -
-                dynamic_gateway_amt(self.context.amount_auth))
-            xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
         # Hostel Maintenance
         elif self.context.p_category == 'hostel_maintenance':
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13409)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13410)
@@ -140,5 +140,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="School Fee plus" '
+            'item_name="School Fee Plus" '
             'item_amt="4600000" bank_id="7" '
             'acct_num="1014847058"' in self.browser.contents)
@@ -215,5 +215,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Acceptance Fee plus" '
+            'item_name="Acceptance Fee Plus" '
             'item_amt="4000000" bank_id="117" '
             'acct_num="1014066976"' in self.browser.contents)
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13409)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13410)
@@ -151,5 +151,6 @@
             text += (', %s Naira Student Welfare Assurance Fee and %s Naira Students\' Union Dues'
                      % (welfare_fee, union_fee))
-        elif self.context.p_category == 'clearance_incl' and academic_session:
+        elif self.context.p_category in (
+            'clearance_incl', 'clearance_medical_incl') and academic_session:
             matric_gown_fee = academic_session.matric_gown_fee - dynamic_gateway_amt(
                 academic_session.matric_gown_fee)
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py	(revision 13409)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/utils.py	(revision 13410)
@@ -132,6 +132,4 @@
         elif category == 'concessional':
             amount = academic_session.concession_fee
-        elif category == 'medical':
-            amount = academic_session.medical_fee
         elif category.startswith('clearance'):
             if student.faccode == 'FP':
@@ -145,11 +143,12 @@
             p_item = student['studycourse'].certificate.code
             # Add Matric Gown Fee and Lapel Fee
-            if category == 'clearance_incl':
+            if category.endswith('_incl'):
                 if amount is None:
                     # Otherwise we can't add somtehing
                     amount = 0.0
                 amount += academic_session.matric_gown_fee + \
-                          academic_session.lapel_fee - \
-                          2*(dynamic_gateway_amt(amount))
+                    academic_session.lapel_fee - \
+                    dynamic_gateway_amt(academic_session.matric_gown_fee) -\
+                    dynamic_gateway_amt(academic_session.lapel_fee)
         elif category == 'late_registration':
             amount = academic_session.late_registration_fee
@@ -187,6 +186,7 @@
                     amount = 0.0
                 amount += academic_session.welfare_fee + \
-                          academic_session.union_fee - \
-                          2*(dynamic_gateway_amt(amount))
+                    academic_session.union_fee - \
+                    dynamic_gateway_amt(academic_session.welfare_fee) -\
+                    dynamic_gateway_amt(academic_session.union_fee)
         if amount in (0.0, None):
             return _(u'Amount could not be determined.'), None
Index: main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 13409)
+++ main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 13410)
@@ -31,7 +31,10 @@
         'schoolfee_1': 'School Fee 1st instalment',
         'schoolfee_2': 'School Fee 2nd instalment',
-        'schoolfee_incl': 'School Fee plus',
+        'schoolfee_incl': 'School Fee Plus',
         'clearance': 'Acceptance Fee',
-        'clearance_incl': 'Acceptance Fee plus',
+        'clearance_incl': 'Acceptance Fee Plus',
+        'clearance_medical': 'Medical Student Acceptance Fee',
+        'clearance_medical_incl': 'Medical Student Acceptance Fee Plus',
+        'medical': 'Medical Student Acceptance Fee', # deprecated
         'hostel_maintenance': 'Hostel Maintenance Fee',
         'application': 'Application Fee',
@@ -46,5 +49,4 @@
         'matric_gown': 'Matriculation Gown Fee',
         'concessional': 'Concessional Fee',
-        'medical': 'Medical Student Acceptance Fee',
         }
 
@@ -53,7 +55,9 @@
         #'schoolfee_1': 'School Fee 1st instalment',
         #'schoolfee_2': 'School Fee 2nd instalment',
-        'schoolfee_incl': 'School Fee plus Students\' Union and Welfare Assurance fees',
+        'schoolfee_incl': 'School Fee + Students\' Union Dues + Welfare Assurance Fee',
         'clearance': 'Acceptance Fee without additional fees',
-        'clearance_incl': 'Acceptance Fee plus Matric Gown and Lapel/File fees',
+        'clearance_incl': 'Acceptance Fee + Matric Gown Fee + Lapel/File Fee',
+        'clearance_medical': 'Medical Student Acceptance Fee',
+        'clearance_medical_incl': 'Medical Student Acceptance Fee + Matric Gown Fee + Lapel/File Fee',
         'hostel_maintenance': 'Hostel Maintenance Fee',
         'application': 'Application Fee',
@@ -68,5 +72,4 @@
         'matric_gown': 'Matriculation Gown Fee',
         'concessional': 'Concessional Fee',
-        'medical': 'Medical Student Acceptance Fee',
         }
 