Index: /main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py	(revision 13420)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py	(revision 13421)
@@ -57,5 +57,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['clearance']
+        self.browser.getControl(name="form.p_category").value = ['clearance_incl']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -65,5 +65,5 @@
 
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -108,5 +108,5 @@
             'FeeStatus=unpaid~'
             'Semester=N/A~'
-            'PaymentType=School Fee~'
+            'PaymentType=School Fee Plus~'
             'MatricNumber=E1000000~'
             'Email=aa@aa.ng~'
@@ -164,5 +164,5 @@
             'FeeStatus=unpaid~'
             'Semester=N/A~'
-            'PaymentType=School Fee~'
+            'PaymentType=School Fee Plus~'
             'MatricNumber=E1000000~'
             'Email=aa@aa.ng~'
Index: /main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13420)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13421)
@@ -154,5 +154,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         self.assertTrue('ticket created' in
@@ -182,5 +182,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="School Fee" item_amt="4750000" bank_id="117" '
+            'item_name="School Fee Plus" item_amt="4750000" bank_id="117" '
             'acct_num="1010827641"' in self.browser.contents)
 
@@ -228,5 +228,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['clearance']
+        self.browser.getControl(name="form.p_category").value = ['clearance_incl']
         self.browser.getControl("Create ticket").click()
         self.assertTrue('ticket created' in self.browser.contents)
@@ -245,10 +245,10 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Acceptance Fee" item_amt="4280000" bank_id="117" '
+            'item_name="Acceptance Fee Plus" item_amt="4280000" bank_id="117" '
             'acct_num="1010827641"' in self.browser.contents)
 
-    def test_interswitch_form_welfare_fees(self):
+    def test_interswitch_form_concession_fees(self):
         self.certificate.study_mode = 'ug_pt'
-        self.app['configuration']['2004'].welfare_fee = 1567.0
+        self.app['configuration']['2004'].concession_fee = 1567.0
         # Manager can access InterswitchForm
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
@@ -257,5 +257,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['welfare']
+        self.browser.getControl(name="form.p_category").value = ['concessional']
         self.browser.getControl("Create ticket").click()
         self.assertTrue('ticket created' in  self.browser.contents)
@@ -269,5 +269,5 @@
         self.certificate.study_mode = 'ug_ft'
         self.browser.getLink("CollegePAY", index=0).click()
-        self.assertTrue('<input type="hidden" name="pay_item_id" value="105" />'
+        self.assertTrue('<input type="hidden" name="pay_item_id" value="107" />'
                            in self.browser.contents)
         self.assertTrue('Total Amount Authorized:' in self.browser.contents)
@@ -276,6 +276,6 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Student Welfare Assurance Fee" item_amt="131700" '
-            'bank_id="123" acct_num="1006407792"'
+            'item_name="Concessional Fee" item_amt="131700" '
+            'bank_id="117" acct_num="1010835352"'
             in self.browser.contents)
 
@@ -320,5 +320,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         self.assertTrue('ticket created' in self.browser.contents)
Index: /main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 13420)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 13421)
@@ -116,5 +116,5 @@
         self.browser.open(self.payments_path)
         self.browser.getLink("Add current session payment ticket").click()
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...Wrong state...',
@@ -131,5 +131,5 @@
         #                   self.browser.contents)
         self.app['configuration']['2004'].clearance_fee = 666.0
-        self.browser.getControl(name="form.p_category").value = ['clearance']
+        self.browser.getControl(name="form.p_category").value = ['clearance_incl']
         self.browser.getControl("Create ticket").click()
         ctrl = self.browser.getControl(name='val_id')
@@ -139,5 +139,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -169,5 +169,5 @@
         # ... no further school fee ticket can be added.
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...Wrong state...',
@@ -243,5 +243,5 @@
         IWorkflowState(self.student).setState('cleared')
         self.browser.getLink("Add current session payment ticket").click()
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_incl']
         self.browser.getControl("Create ticket").click()
         ctrl = self.browser.getControl(name='val_id')
@@ -265,5 +265,5 @@
         self.assertTrue(
             'zope.mgr - students.browser.OnlinePaymentApproveView '
-            '- E1000000 - schoolfee payment approved'
+            '- E1000000 - schoolfee_incl payment approved'
             in logcontent)
         # ... and in payments.log
@@ -272,5 +272,5 @@
         logcontent = open(logfile).read()
         self.assertTrue(
-            '"zope.mgr",E1000000,%s,schoolfee,6666.0,AP,,,,,,\n' % value
+            '"zope.mgr",E1000000,%s,schoolfee_incl,6666.0,AP,,,,,,\n' % value
             in logcontent)
         # Student is in state school fee paid, no activation