Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py	(revision 13421)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py	(revision 13422)
@@ -25,4 +25,5 @@
 from zope.formlib.textwidgets import BytesDisplayWidget
 from waeup.kofa.utils.helpers import string_from_bytes, file_size
+from waeup.kofa.applicants.browser import ApplicantCheckStatusPage
 from waeup.aaue.interfaces import MessageFactory as _
 from kofacustom.nigeria.applicants.browser import (
@@ -173,2 +174,7 @@
     def payment_slip_download_warning(self):
         return ''
+
+class CustomApplicantCheckStatusPage(ApplicantCheckStatusPage):
+    """Captcha'd status checking page for applicants.
+    """
+    grok.template('applicantcheckstatus')
Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser_templates/applicantcheckstatus.pt
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser_templates/applicantcheckstatus.pt	(revision 13422)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser_templates/applicantcheckstatus.pt	(revision 13422)
@@ -0,0 +1,77 @@
+<form method="post" enctype="multipart/form-data"
+    tal:condition="not:view/result" i18n:domain="waeup.kofa">
+<br />
+  <table class="form-table">
+    <tr>
+      <td i18n:translate="" class="fieldname">
+        Registration Number or Applicant Id:
+      </td>
+      <td>
+        <input class="textType half" type="text" name="unique_id" />
+      </td>
+    </tr>
+    <tr>
+      <td i18n:translate="" class="fieldname">
+        Lastname (Surname):
+      </td>
+      <td>
+        <input class="textType half" type="text" name="lastname" />
+      </td>
+    </tr>
+    <tr tal:condition="view/captcha_code">
+      <td i18n:translate="">
+        Please solve the captcha<br />to prevent misuse of this service:
+      </td>
+      <td>
+        <div tal:content="structure view/captcha_code"></div>
+      </td>
+    </tr>
+  </table>
+  <br />
+  <input class="btn btn-primary" type="submit" name="SUBMIT"
+      tal:attributes="value view/buttonname" />
+</form>
+
+<div tal:condition="view/result" i18n:domain="waeup.kofa">
+  <br />
+  <tal:admitted condition="view/admitted">
+    <p i18n:translate="app_admitted">
+      <strong>Congratulations <span tal:replace="view/applicant/display_fullname"></span></strong>
+      <br /><br />
+      You have been offered provisional
+      admission into the <span  i18n:name="entry_session" tal:replace="view/entry_session"></span>
+      Academic Session of <span  i18n:name="app_title" tal:replace="layout/getAppTitle"></span>.
+    </p>
+  </tal:admitted>
+  <tal:created condition="view/created">
+    <p i18n:translate="appl_created">
+      Your student record has already been created for you. Your new
+      user name (= student id) is: <strong><span  i18n:name="student_id"
+      tal:replace="view/student_id">STUDENT_ID</span></strong>.
+      Your initial password is: <strong><span  i18n:name="appl_number"
+      tal:replace="view/password">PASSWORD</span></strong>.
+      Please proceed to the <a  i18n:name="login_url"
+      tal:attributes="href python: view.url(layout.site, 'login')">login form</a>,
+      enter your new login credentials and change your password immediately after login.
+    </p>
+  </tal:created>
+
+  <tal:notadmitted condition="view/not_admitted">
+    <p i18n:translate="">
+      Sorry, you have not been offered admission.
+    </p>
+  </tal:notadmitted>
+
+  <tal:submitted condition="view/submitted">
+    <p i18n:translate="">
+      Your submitted application is being processed.
+    </p>
+  </tal:submitted>
+
+  <tal:notsubmitted condition="view/not_submitted">
+    <p i18n:translate="">
+      You have not yet submitted your application.
+    </p>
+  </tal:notsubmitted>
+
+</div>
Index: main/waeup.aaue/trunk/src/waeup/aaue/etranzact/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/etranzact/browser.py	(revision 13421)
+++ main/waeup.aaue/trunk/src/waeup/aaue/etranzact/browser.py	(revision 13422)
@@ -85,4 +85,5 @@
                 return
         if PAYMENT_TYPE not in ('SCHOOL-FEE-RETURNING', 'SCHOOL-FEE-NEW',
+            'SCHOOL-FEE-PLUS', 'APPLICATION-FEE-PLUS',
             'ACCEPTANCE-FEE', 'APPLICATION-FEE', 'LATE-REGISTRATION',
             'AAU-STUDENT-WELFARE-ASSURANCE','HOSTEL-ACCOMMODATION-FEE',