Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 13430)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 13431)
@@ -1624,4 +1624,7 @@
 
     def update(self, back=None, finish=None, showlog=None):
+        if finish is not None:
+            self.redirect(self.url(self.context, '@@import1'))
+            return
         if not grok.getSite()['configuration'].maintmode_enabled_by and \
             not self.request.principal.id == 'admin':
@@ -1631,7 +1634,4 @@
                 type='danger')
             self.redirect(self.url(self.context))
-            return
-        if finish is not None:
-            self.redirect(self.url(self.context, '@@import1'))
             return
         session = ISession(self.request)['waeup.kofa']
@@ -1882,5 +1882,5 @@
             self.context.logger.info('%s - maintmode enabled' % ob_class)
             self.flash(_('Maintenance mode enabled.'), type='warning')
-        self.redirect(self.url(self.context))
+        self.redirect(self.url(self.context, 'import1'))
         return
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py	(revision 13430)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py	(revision 13431)
@@ -26,5 +26,5 @@
     UniversityPage, FacultiesContainerPage, DatacenterPage, FacultyPage,
     DepartmentPage, CoursePage, CertificatePage, CertificateCoursePage,
-    UsersContainerPage, UserManageFormPage)
+    UsersContainerPage, UserManageFormPage, DatacenterImportStep1)
 from waeup.kofa.browser.interfaces import (
     IFacultiesContainer, IFaculty, IDepartment, ICourse, ICertificate,
@@ -631,5 +631,5 @@
     grok.context(IDataCenter)
     grok.require('waeup.importData')
-    grok.view(DatacenterPage)
+    grok.view(DatacenterImportStep1)
     grok.order(7)
     icon = 'actionicon_stop.png'
Index: /main/waeup.kofa/trunk/src/waeup/kofa/doctests/batchprocessing_browser.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/doctests/batchprocessing_browser.txt	(revision 13430)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/doctests/batchprocessing_browser.txt	(revision 13431)
@@ -86,6 +86,6 @@
 Step 1: start batch processing:
 
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'faculties_zope.mgr.csv', browser)
@@ -100,4 +100,5 @@
     'Applicant Processor',
     'ApplicantsContainer Processor',
+    'Bed Processor (update only)',
     'CertificateCourse Processor',
     'Certificate Processor',
@@ -192,6 +193,6 @@
 Step 1: start batch processing:
 
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'departments_zope.mgr.csv', browser)
@@ -258,6 +259,6 @@
 Step 1: start batch processing:
 
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'courses_zope.mgr.csv', browser)
@@ -324,6 +325,6 @@
 Step 1: start batch processing:
 
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'certificates_zope.mgr.csv', browser)
@@ -391,6 +392,6 @@
 Step 1: start batch processing:
 
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'mycertcourses_zope.mgr.csv', browser)
@@ -458,6 +459,6 @@
 Step 1: start batch processing:
 
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'users_zope.mgr.csv', browser)
@@ -545,6 +546,6 @@
 Step 1: start batch processing:
 
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'newfaculties_zope.mgr.csv', browser)
@@ -609,6 +610,6 @@
 
     >>> browser.open('http://localhost/app/datacenter')
-    >>> browser.getLink('Switch maintenance mode').click()
-    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Process data').click()
+    >>> browser.getLink('Switch maintenance mode').click()
     >>> button = lookup_submit_value(
     ...   'select', 'newfaculties_zope.mgr.create.pending.csv', browser)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 13430)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 13431)
@@ -1387,6 +1387,6 @@
         filewidget.add_file(filecontents, 'text/plain', 'students.csv')
         self.browser.getControl(name='SUBMIT').click()
+        self.browser.getLink('Process data').click()
         self.browser.getLink("Switch maintenance mode").click()
-        self.browser.getLink('Process data').click()
         button = lookup_submit_value(
             'select', 'students_zope.mgr.csv', self.browser)
@@ -1414,7 +1414,7 @@
         filewidget.add_file(filecontents, 'text/plain', 'studycourses.csv')
         self.browser.getControl(name='SUBMIT').click()
+        self.browser.getLink('Process data').click()
         # Meanwhile maintenance mode is disabled again.
         self.browser.getLink("Switch maintenance mode").click()
-        self.browser.getLink('Process data').click()
         button = lookup_submit_value(
             'select', 'studycourses_zope.mgr.csv', self.browser)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_batching.py	(revision 13430)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_batching.py	(revision 13431)
@@ -353,5 +353,4 @@
         self.assertTrue('Portal must be in maintenance mode for data import.'
             in self.browser.contents)
-        self.browser.open(self.datacenter_path)
         self.browser.getLink("Switch").click()
         self.assertTrue('Maintenance mode enabled' in self.browser.contents)
@@ -359,5 +358,4 @@
         self.assertEqual(
             self.app['configuration'].maintmode_enabled_by, 'zope.mgr')
-        self.browser.getLink('Process data').click()
         self.browser.getControl(name="select").click()
         importerselect = self.browser.getControl(name='importer')