Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 13436)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 13437)
@@ -50,7 +50,7 @@
 
 def gateway_net_amt(fee):
-    if fee > GATEWAY_AMT:
+    if fee > 2000:
         return fee - GATEWAY_AMT
-    return 0.0
+    return round(fee * 0.985, 2)
 
 def contr_agreement(student):
@@ -380,5 +380,6 @@
         self.xml_data = """<input type="hidden" name="xml_data" value='%s'  />""" % xmltext
         self.context.provider_amt = provider_amt
-        self.context.gateway_amt = GATEWAY_AMT
+        self.context.gateway_amt = self.amount_auth - gateway_net_amt(
+            self.amount_auth)
         hashargs = (
             self.context.p_id +
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13436)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13437)
@@ -121,6 +121,6 @@
         self.browser.getLink(self.value).click()
         self.assertTrue('Amount Authorized' in self.browser.contents)
-        # 50250 + 1000 + 500 - 500
-        self.assertTrue('<span>51250.0</span>' in self.browser.contents)
+        # 50250 + 0.985 * (1000 + 500)
+        self.assertTrue('<span>51727.5</span>' in self.browser.contents)
         self.payment_url = self.browser.url
         self.browser.getLink("CollegePAY", index=0).click()
@@ -137,5 +137,5 @@
         self.assertEqual(self.student.current_mode, 'ug_pt')
         self.assertTrue(
-            '<input type="hidden" name="amount" value="5125000" />'
+            '<input type="hidden" name="amount" value="5172750" />'
             in self.browser.contents)
         self.assertTrue(
@@ -204,6 +204,6 @@
         self.browser.getLink(self.value).click()
         self.assertTrue('Amount Authorized' in self.browser.contents)
-        # 40250 + 2000 + 800 -500
-        self.assertTrue('<span>42550.0</span>' in self.browser.contents)
+        # 40250 + 0.985 * (2000 + 800)
+        self.assertTrue('<span>43008.0</span>' in self.browser.contents)
         self.payment_url = self.browser.url
         self.browser.getLink("CollegePAY", index=0).click()
@@ -212,5 +212,5 @@
         self.assertTrue('Total Amount Authorized:' in self.browser.contents)
         self.assertTrue(
-            '<input type="hidden" name="amount" value="4255000" />'
+            '<input type="hidden" name="amount" value="4300800" />'
             in self.browser.contents)
         self.assertTrue(
@@ -276,5 +276,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Concessional Fee" item_amt="131700" '
+            'item_name="Concessional Fee" item_amt="154349" '
             'bank_id="117" acct_num="1010835352"'
             in self.browser.contents)
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13436)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13437)
@@ -146,7 +146,7 @@
             welfare_fee = gateway_net_amt(academic_session.welfare_fee)
             union_fee = gateway_net_amt(academic_session.union_fee)
-            text += ('School Fee'
-                     ', %s Naira Students\' Union Dues'
-                     ', %s Naira Student Welfare Assurance Fee'
+            text += ('School Fee, '
+                     '%s Naira Students\' Union Dues, '
+                     '%s Naira Student Welfare Assurance Fee and '
                      % (union_fee, welfare_fee))
         elif self.context.p_category in (
@@ -154,9 +154,9 @@
             matric_gown_fee = gateway_net_amt(academic_session.matric_gown_fee)
             lapel_fee = gateway_net_amt(academic_session.lapel_fee)
-            text += ('Acceptance Fee'
-                     ', %s Naira Matriculation Gown Fee'
-                     ', %s Naira Lapel/File Fee'
+            text += ('Acceptance Fee, '
+                     '%s Naira Matriculation Gown Fee, '
+                     '%s Naira Lapel/File Fee and '
                      % (matric_gown_fee, lapel_fee))
-        return text + ' and 250.0 Naira Transaction Charge.'
+        return text + '250.0 Naira Transaction Charge.'
 
 class CustomStudyLevelDisplayFormPage(StudyLevelDisplayFormPage):
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 13436)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 13437)
@@ -300,6 +300,6 @@
         self.student['studycourse'].entry_session = 2013
         self.student['studycourse'].certificate.school_fee_1 = 50250.0
-        self.app['configuration']['2004'].union_fee = 1000.0
-        self.app['configuration']['2004'].welfare_fee = 500.0
+        self.app['configuration']['2004'].union_fee = 1015.23
+        self.app['configuration']['2004'].welfare_fee = 507.61
         self.student.nationality = u'NG'
         # Login
@@ -319,5 +319,5 @@
         self.browser.getLink(value).click()
         self.assertTrue('Amount Authorized' in self.browser.contents)
-        self.assertEqual(self.student['payments'][value].amount_auth, 51250.0)
+        self.assertEqual(self.student['payments'][value].amount_auth, 51750.0)
         self.browser.open(self.browser.url + '/payment_slip.pdf')
         self.assertEqual(self.browser.headers['Status'], '200 Ok')