Index: main/waeup.kofa/trunk/layout/rules.xml
===================================================================
--- main/waeup.kofa/trunk/layout/rules.xml	(revision 13512)
+++ main/waeup.kofa/trunk/layout/rules.xml	(revision 13513)
@@ -48,4 +48,10 @@
     <replace css:theme-children="ul.kofa-navbar-right"
              css:content-children="ul.kofa-navbar-right" />
+
+    <!-- maintenance mode warning -->
+    <drop css:theme="div.kofa-maintenance"
+          css:if-not-content="div.maintenance-warning" />
+    <replace css:theme-children="div.maintenance-warning"
+             css:content-children="div.maintenance-warning" />
 
     <!-- breadcrumbs -->
Index: main/waeup.kofa/trunk/layout/static/css/base.css
===================================================================
--- main/waeup.kofa/trunk/layout/static/css/base.css	(revision 13512)
+++ main/waeup.kofa/trunk/layout/static/css/base.css	(revision 13513)
@@ -32,5 +32,5 @@
 }
 
-.breadcrumb , .wfstatus {
+.breadcrumb , .wfstatus, .maintenance-warning {
     background-color: #fff;
     margin-bottom: 0px;
@@ -69,5 +69,6 @@
 .kofa-breadcrumbs-box-short,
 .kofa-breadcrumbs-box-long,
-.kofa-student-status-box {
+.kofa-student-status-box,
+.kofa-maintenance {
     padding: 0px 5px 0px 5px;
 }
@@ -85,5 +86,6 @@
 .kofa-breadcrumbs-box-short .well,
 .kofa-breadcrumbs-box-long .well,
-.kofa-student-status-box .well {
+.kofa-student-status-box .well,
+.kofa-maintenance .well {
     padding: 5px 5px 5px 5px;
 }
@@ -106,4 +108,12 @@
 .kofa-student-status-box .well {
     background-color: #909090;
+}
+
+.maintenance-warning {
+    text-align: center;
+}
+
+.kofa-maintenance .well {
+    background-color: red;
 }
 
Index: main/waeup.kofa/trunk/layout/theme.html
===================================================================
--- main/waeup.kofa/trunk/layout/theme.html	(revision 13512)
+++ main/waeup.kofa/trunk/layout/theme.html	(revision 13513)
@@ -90,4 +90,14 @@
 
       <div class="row">
+        <div class="col-md-12 container kofa-maintenance">
+          <div class="well">
+            <div class="maintenance-warning">
+                M A I N T E N A N C E &nbsp;&nbsp;&nbsp; M O D E
+            </div> <!-- /maintenance-warning -->
+          </div> <!-- /well -->
+        </div> <!-- /kofa-maintenance -->
+      </div>
+
+      <div class="row">
         <div class="col-md-12 container kofa-breadcrumbs-box-long">
           <div class="well">
@@ -115,5 +125,5 @@
             </ol><!-- /kofa-breadcrumbs -->
           </div> <!-- /well -->
-        </div> <!-- /kofa-breadcrumbs-box-short -->
+        </div> <!-- /kofa-breadcrumbs-box-long -->
       </div>
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/layout.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/layout.py	(revision 13512)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/layout.py	(revision 13513)
@@ -240,4 +240,11 @@
         return usertitle != 'Unauthenticated User'
 
+    def isMaintenanceMode(self):
+        """Return True if portal is in maintenance mode.
+        """
+        if grok.getSite()['configuration'].maintmode_enabled_by:
+            return True
+        return False
+
     def getUserTitle(self):
         """Return principal title of current user.
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/staffsitelayout.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/staffsitelayout.pt	(revision 13512)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/staffsitelayout.pt	(revision 13513)
@@ -63,4 +63,13 @@
       <tal:languages tal:content="structure langs" /> |
     </span>
+
+    <!-- Diazo element-->
+    <span tal:condition="layout/isMaintenanceMode">
+      <div class="maintenance-warning" i18n:translate="">
+          M A I N T E N A N C E &nbsp;&nbsp;&nbsp;
+          M O D E &nbsp;&nbsp;&nbsp; O N
+      </div>
+    </span>
+    <!-- /Diazo element-->
 
     <!-- Diazo element-->